/*
 * machine dependencies
 *
 */

#define	USGV4	1		/* define if 3.0 or 4.0 UNIX */
				/* if not defined or undef USGV4, UNIX is 5.0 */

#ifdef	USGV4
#define	strchr	index
#define srand48	srandom
#define lrand48	random
#endif

/*
 * Variables for checking to make sure the system isn't too loaded
 * for people to play
 */

#define	MAXUSERS	16	/* max number of users for this game */
#define	MAXLOAD		40	/* 10 * max 15 minute load average */

#if MAXUSERS|MAXLOAD 

#define	CHECKTIME	5	/* number of minutes between load checks */
			/* if not defined checks are only on startup */
#endif

#ifdef MAXLOAD

#define	LOADAV			/* defined if rogue should provide loadav() */
#define	NAMELIST	"/vmunix"	/* where the system namelist lives */

#endif



#ifdef MAXUSERS

#define	UCOUNT			/* defined if rogue should provide ucount() */
#define UTMP	"/etc/utmp"	/* where utmp file lives */

#endif

/*#define HOLIDAY	1	/* is playing allowed during working hours? */

/*
 * define the current author of the program for "special handling"
 */
#define AUTHOR 7
