/** signals.h                                 **/
/** architecture-customized signals.h for zsh **/

#define SIGCOUNT	0

#ifdef GLOBALS

char *sigmsg[SIGCOUNT+2] = {
	"done",
	NULL
};

char *sigs[SIGCOUNT+4] = {
	"EXIT",
	"ZERR",
	"DEBUG",
	NULL
};

#else
extern char *sigs[SIGCOUNT+4],*sigmsg[SIGCOUNT+2];
#endif
