/* src/sysconf.h.  Generated automatically by configure.  */
/* -*- C -*- */

/* Note: this is for unix only. */

#ifndef JED_CONFIG_H
#define JED_CONFIG_H

/* define if you have stdlib.h */
#define HAVE_STDLIB_H 1

/* define if you have unistd.h */
#define HAVE_UNISTD_H 1

/* define if you have termios.h */
#define HAVE_TERMIOS_H 1

/* define if you have memory.h */
#define HAVE_MEMORY_H 1

/* define if you have memset */
#define HAVE_MEMSET 1

/* define if you have memcpy */
#define HAVE_MEMCPY 1

/* define if you have this. */
#define HAVE_PUTENV 1
#define HAVE_GETCWD 1
#define HAVE_TCGETATTR 1
#define HAVE_TCSETATTR 1
#define HAVE_CFGETOSPEED 1

#define HAVE_SYS_WAIT_H 1
#define HAVE_DIRENT_H 1
/* #undef HAVE_SYS_NDIR_H */
/* #undef HAVE_SYS_DIR_H */
/* #undef HAVE_NDIR_H */

/* Random number defines */
#define HAVE_RAND 1
#define HAVE_SRAND 1
#define HAVE_LRAND48 1
#define HAVE_SRAND48 1

/* #undef mode_t */
/* #undef pid_t */
/* #undef uid_t */

/* This is for AIX */
#ifndef  _ALL_SOURCE
/* # undef _ALL_SOURCE */
#endif


/* Undefine this to disable floating point support. */
#define FLOAT_TYPE

#if defined(ultrix) && !defined(__GNUC__)
# ifndef NO_PROTOTYPES
#  define NO_PROTOTYPES
# endif
#endif

#ifndef REAL_UNIX_SYSTEM
# define REAL_UNIX_SYSTEM
#endif

/* It is safe to leave these untouched. */
#define HAS_ABBREVS
#define COLOR_COLUMNS
#define HAS_DISPLAY_TABLE
#define HAS_MOUSE

#ifdef _AIX
# ifndef _POSIX_SOURCE
#  define _POSIX_SOURCE
# endif
# ifndef _ALL_SOURCE
#  define _ALL_SOURCE
# endif
#endif

#endif /* JED_CONFIG_H */
